package com.order.controller.notify;

import com.alibaba.fastjson.JSONObject;
import com.hfkj.common.utils.HttpsUtils;
import com.hfkj.common.utils.RedisUtil;
import com.hfkj.config.CommonSysConst;
import com.hfkj.jd.JdPostService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.PrintWriter;

@Controller
@RequestMapping(value = "/jdNotify")
@Api(value = "京东回调")
public class JdNotify {
    private static final Logger log = LoggerFactory.getLogger(JdPostService.class);


    @Autowired
    private RedisUtil redisUtil;

    @RequestMapping(value = "/callbackToken", method = RequestMethod.GET)
    @ApiOperation(value = "token回调")
    @ResponseBody
    public void notify(@RequestParam("code") String code) {
        try {

            log.info("============token回调任务Start=============");
            log.info("token回调 code-回调参数: " + code);
            JSONObject object = new JSONObject();
            object.put("app_key", CommonSysConst.getSysConfig().getJDAppKey());
            object.put("app_secret", CommonSysConst.getSysConfig().getJDAppSecret());
            object.put("code", code);
            object.put("grant_type", "authorization_code");
            JSONObject jsonObject = HttpsUtils.doGet("https://open-oauth.jd.com/oauth2/access_token", object);
            log.info("token回调 jsonObject-回调参数: " + jsonObject);
            log.info("token回调 access_token-回调参数: " + jsonObject.getString("access_token"));
            redisUtil.set("access_token", jsonObject.getString("access_token") , jsonObject.getInteger("expires_in") - 10000);
            log.info("============token回调任务End=============");

        } catch (Exception e) {
            log.error("WechatPayController --> wechatNotify() error!", e);
        }
    }
}
